#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    int n,x,y;
    cin>>n;
    for(int i=1;i<n;i++){
        cin>>x>>y;
    }
    if(n==2){
        cout<<0;
        return 0;
    }
    if(n%2==0){
        cout<<n-3;
        return 0;
    }
    cout<<n-2;
    return 0;
}